<script setup lang="ts">
import { computed } from '@vue/reactivity';

const emits = defineEmits<{
    (event: "treePathChangedEvent", path: string[]) : void
}>();


const props = defineProps({
    treePath: {
        type: Array,
        default() {
            return ["test1", "test2", "test3"]
        }
    },
	selectableChildren: {
		type: Array,
		default() {
			return []
		}
	}
})


const aboutRoute = {name:"About"};

const breadcrumbComputedData = computed( () => {
    const data = ["Overview", ...props.treePath];
    return data.map( (e, i) => [e, i < data.length - 1]) // Returns name and if can be clicked.
})

const notifyAboutBreadcrumbClicked = (index: number) => {
    const newTreePath = []
    for(let i = 0; i < index; i++)  {
        newTreePath.push(props.treePath[i] as string)
    }
    emits("treePathChangedEvent", newTreePath)
}

const handleChildSelected = (childId: string) => {
	const newTreePath: string[] = [...props.treePath as string[], childId];
	emits("treePathChangedEvent", newTreePath)
}

</script>

<template>
<QBar class="topBar text-white">
    <QBreadcrumbs>
        <QBreadcrumbsEl @click="notifyAboutBreadcrumbClicked(index)" :linkable="entry[1]" v-for="(entry, index) in breadcrumbComputedData" class="topBarBreadCrumb" :label="(entry[0] as string)" />
		<QBreadcrumbsEl v-if="selectableChildren.length > 0">
			<QBtnDropdown class="q-pr-md q-pl-none" flat dropdown-icon="chevron_right">
				<QList>
					<QItem v-for="(entry, index) in selectableChildren" clickable @click="()=>handleChildSelected(entry as string)">
						<QItemSection>
							<QItemLabel>{{entry}}</QItemLabel>
						</QItemSection>
					</QItem>
				</QList>
			</QBtnDropdown>
		</QBreadcrumbsEl>
	</QBreadcrumbs>
    <QSpace/>

    <QBtn flat :to="aboutRoute">About</QBtn>


</QBar>
</template>

<style lang="scss">
.topBar {
    background-color: adjust-color($color: $primary, $alpha: -.8);
}
.topBarBreadCrumb[linkable=true] {
    cursor: pointer;
    text-decoration: underline;
    opacity: .7;
    &:hover {
        opacity: 1;
    }
}
</style>
